.IMPORT __ONCE_LOAD__
.IMPORT __ONCE_SIZE__
.IMPORT __CARTSTUB_LOAD__
.IMPORT __MAIN_START__

.SEGMENT "BASICSTUB"

basic_stub_start:

.INCBIN "basic_stub-c64.bin"

basic_stub_end:

.RES 97-(basic_stub_end-basic_stub_start),$ff

basicstart:
	sei
	jsr $fd15
	jsr $e453
	cli
	jmp __MAIN_START__

.SEGMENT "SIZE"

.WORD __ONCE_LOAD__ + __ONCE_SIZE__ - __CARTSTUB_LOAD__

.SEGMENT "CARTSTUB"

cartridge_sub:

.ORG $8000

.WORD coldstart
.WORD warmstart
.BYTE $c3,$c2,$cd,$38,$30  ; CBM80

coldstart:
	sei
	stx $d016
	jsr $fda3
	jsr $fd50
	jsr $fd15
	jsr $ff5b
	cli

warmstart:
	lda #$80
	sta $03
	asl      ; A = 0
	sta $02  ; ($02) = $8000
	sta $04
	tay
	lda #$10
	sta $05  ; ($04) = $1000

	; Copy program
@a1:
	lda ($02),y
	sta ($04),y
	iny
	bne @a1
	inc $05
	inc $03
	ldx $03
	cpx #$b8
	bne @a1

	; Copy font
	lda #$08
	sta $05
@a2:
	lda ($02),y
	sta ($04),y
	iny
	bne @a2
	inc $05
	inc $03
	ldx $03
	cpx #$c0
	bne @a2

	jmp @a3 - $7000 ; Code has been copied into RAM
@a3:
	jsr __MAIN_START__
	lda #142  ; Return to uppercase font.
	jsr $ffd2 ; bsout
	lda #$70  ; Cartridge invisible
	sta $dfff
    ; Top of memory at $a000
    ldx #$00
    ldy #$a0
    clc
    jsr $fe2d    ; SETTOP
	
	jmp ($a000)


.if 0

tape_buffer = $033c

;
; The RAM test in KERNAL takes a long time and Doing a full RAM test during
; boot is a bit pointless for FC3 flashinh purposes, so this routine
; duplicates the KERNAL RAMTAS routine at $ff87 without the RAM test.
;

.proc fast_ramtas
        lda #0
        tay
@1:
        sta $0002,y
        Sta $0200,y
        sta $0300,y
        iny
        bne @1

        ldx #<tape_buffer
        ldy #>tape_buffer
        stx $b2
        sty $b3

        ; Top of memory at $a000
        ldx #$00
        ldy #$a0
        clc
        jsr $fe2d    ; SETTOP
        lda #$08     ; Bottom of memory at $0800
        sta $0282
        lsr          ; Screen RAM a $0400
        sta $0288
        rts
.endproc

.endif

.SEGMENT "FONTL"

.INCBIN "maschine_font.bin",$0000,$0080

.SEGMENT "FONTH"

.INCBIN "maschine_font.bin",$0080,$0780
